Summary: A Perl interpreter for the Apache Web server.
Summary(fr): Un interpreteur Perl pour le serveur web Apache
Name: mod_perl
Version: 1.22
Release: 28mdk
%define apache_version 1.3.12
%define apache_release 12mdk    
Group: System/Servers
Source0: http://www.perl.com/CPAN/by-module/Apache/%{name}-%{version}.tar.bz2
Source1: mod_perl.conf
Source2: mod_perl.html
Patch0: mod_perl-1.22.fix_typo.patch.bz2
Copyright: GPL
BuildRoot: /var/tmp/%{name}-root
BuildRequires: perl-libwww-perl
Requires: apache >= %{apache_version}-%{apache_release}, perl >= 5.600
Prereq: apache

%description
Mod_perl incorporates a Perl interpreter into the Apache web
server, so that the Apache web server can directly execute Perl
code.  Mod_perl links the Perl runtime library into the Apache
web server and provides an object-oriented Perl interface for
Apache's C language API.  The end result is a quicker CGI script
turnaround process, since no external Perl interpreter has to
be started.

Install mod_perl if you're installing the Apache web server and
you'd like for it to directly incorporate a Perl interpreter.

%description -l fr
Mod_perl incorpore un interpreteur Perl dans le serveur web Apache, qui peut
executer directement le code Perl. Mod_perl linke la librairie run-time de
Perl dans le serveur web Apache et fournit une interface Perl orientee objet
a l'API en langage C de Apache. Le resultat final est un script CGI beaucoup
plus rapide a executer, puisqu'on ne doit demarrer aucun interpreteur Perl
externe.

Installez mod_perl si vous installez le serveur Web Apache et que vous
aimeriez y incorporer directement un interpreteur Perl.


%prep
%setup -q
%patch0 -p1

%build
perl Makefile.PL \
	USE_APXS=1 \
	WITH_APXS=/usr/sbin/apxs \
	EVERYTHING=1

perl -i -ple 's/-D_FILE_OFFSET_BITS=64//' \
		`find . -name Makefile -print`

(cd apaci; ln -s ../src/modules .; chmod +x find_source)
make CFLAGS="$RPM_OPT_FLAGS -DSGI_BOOST -DEAPI -DEAPI_MM"

%install

rm -rf $RPM_BUILD_ROOT
make pure_install PREFIX=$RPM_BUILD_ROOT/usr
cd faq
CFLAGS=" $RPM_OPT_FLAGS" make
cd ..
mkdir -p $RPM_BUILD_ROOT/usr/lib/apache
install -m 755 apaci/libperl.so $RPM_BUILD_ROOT/usr/lib/apache
mkdir -p $RPM_BUILD_ROOT/mod_perl-%{version}
install -m 644 %{SOURCE2} \
	$RPM_BUILD_DIR/mod_perl-%{version}/mod_perl.html

mkdir -p $RPM_BUILD_ROOT/home/httpd/perl
install -m 755 eg/registry.pl \
	$RPM_BUILD_ROOT/home/httpd/perl
mkdir -p $RPM_BUILD_ROOT/etc/httpd/conf/addon-modules
install -m 644 $RPM_SOURCE_DIR/mod_perl.conf \
	$RPM_BUILD_ROOT/etc/httpd/conf/addon-modules

if [ `uname` = "Linux" ]; then
    if [ -d /usr/lib/perl5/site_perl/5.6.0/%{_arch}-linux/auto ] ; then
	PACKLIST=$RPM_BUILD_ROOT/usr/lib/perl5/site_perl/5.6.0/%{_arch}-linux/auto/mod_perl/.packlist
    elif [ -d /usr/lib/perl5/site_perl/%{_arch}-linux/auto ] ; then
	PACKLIST=$RPM_BUILD_ROOT/usr/lib/perl5/site_perl/%{_arch}-linux/auto/mod_perl/.packlist
    fi
fi
if [ `uname` = "SunOS" ]; then
mkdir -p $RPM_BUILD_ROOT/usr/local/lib
mv $RPM_BUILD_ROOT/usr/lib/perl5 $RPM_BUILD_ROOT/usr/local/lib
PACKLIST=$RPM_BUILD_ROOT/usr/local/lib/perl5/site_perl/5.6.0/sun4-solaris/auto/mod_perl/.packlist
fi
mv $PACKLIST $PACKLIST.old
sed -e "s|$RPM_BUILD_ROOT||g" < $PACKLIST.old > $PACKLIST
rm -f $PACKLIST.old

%ifos linux
find $RPM_BUILD_ROOT/ -type 'f'|grep -E '.*[0-9]'|xargs file|grep troff\
|sed s/".3:"/.3#/g|cut -d# -f1|xargs bzip2 -9
for i in $(find $RPM_BUILD_ROOT/usr/man/ -type 'l');do
 	TO=$(/bin/ls -l $i|awk '{print $NF}')
	ln -sf $TO.bz2 $i
done
%endif


for i in `find $RPM_BUILD_ROOT/ -type 'f' -perm '+a=x' ! -name 'lib*so*'`;do
    file $i|grep -q "not stripped" && strip $i
done

%clean
#rm -rf $RPM_BUILD_ROOT

%files 
%defattr(-,root,root)
%dir /etc/
%dir /etc/httpd/conf/addon-modules
%config /etc/httpd/conf/addon-modules/mod_perl.conf
%dir /home/
%dir /home/httpd/
%doc mod_perl.html
%doc faq/*.html
%doc faq/*.txt
%doc ToDo 
%doc apache-modlist.html
%doc README
%doc eg/*.pl
%doc eg/*.txt

/home/httpd/perl/
/usr/

%post
grep -q mod_perl.conf /etc/httpd/conf/httpd.conf || \
echo "Include conf/addon-modules/mod_perl.conf" >> /etc/httpd/conf/httpd.conf
if [ -f /var/run/httpd.pid ]; then 
   /usr/sbin/apachectl restart
fi
ln -s /usr/doc/mod_perl-%{version} /home/httpd/html/addon-modules/mod_perl

%postun
if [ `uname` = "Linux" ]; then perl="/usr/bin/perl"; fi
if [ `uname` = "SunOS" ]; then perl="/usr/local/bin/perl"; fi
$perl -pi -e "s|Include conf/addon-modules/mod_perl.conf\n||g;" \
	/etc/httpd/conf/httpd.conf
if [ -f /var/run/httpd.pid ]; then 
   /usr/sbin/apachectl restart
fi
rm /home/httpd/html/addon-modules/mod_perl

%changelog
* Mon May 08 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.22-28mdk
- added Prereq to fix problem with httpd.conf

* Mon Apr 17 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.22-27mdk
- rebuilt with EAPI 2.6.3
- put doc in /usr/doc

* Wed Apr  5 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.22-26mdk
- cleaned spec again

* Mon Apr  3 2000 Jean-Michel Dault <jmdault@mandrakesoft.com> 1.22-25mdk
- fix bad segfault because of -D_FILE_OFFSET_BITS=64 in Perl 5.6
- fix post scripts

* Fri Mar 31 2000 Pixel <pixel@mandrakesoft.com> 1.22-24mdk
- new version, rebuild for perl 5.6.0, new group

* Tue Feb 29 2000 Jean-Michel Dault <jmdault@netrevolution.com> 1.21-23mdk
- rebuilt for EAPI 2.6.1

* Mon Feb 28 2000 Jean-Michel Dault <jmdault@netrevolution.com> 1.21-22mdk
- added patch to make it compile with SGI-optimized Apache
- integrated patches from Michal (Thanks a lot!)

* Sun Feb 27 2000 Michal Jaegermann <michal@harddata.com>
- fixed wrong macro giving compile errors on alpha
- changed mod_perl.conf to current Apache standards
- Conditional "Include" line in httpd.conf - do not that multiple times
- Fixed image references in mod_perl.html
- added link to 'directive-dict.html' to resolve references in mod_perl.html
- PACKLIST depends on the current Perl - 5.004 works fine.

* Wed Jan  5 2000 Jean-Michel Dault <jmdault@netrevolution.com>
- fixed compilation bug on alpha

* Mon Jan  3 2000 Jean-Michel Dault <jmdault@netrevolution.com>
- final cleanup for Mandrake 7

* Thu Dec 30 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- rebuilt for Mandrake 7.0 and mm 1.0.12

* Mon Sep 06 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- procedure for bzipping man pages was broken. Fixed it.

* Mon Sep 06 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- re-build for EAPI 2.4.2 and mm 1.0.11
- added pentium in buildarch

* Fri Sep 3 1999 Jean-Michel Dault <jmdault@netrevolution.com?
- recompiled for the new mm-1.0.10 in Apache

* Thu Aug 26 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- mod_perl segfaults on Solaris. It seems it will not work as
  a DSO on that platform with 5.00503, but has been fixed in 5.00556.
  We'll have to wait. 

* Tue Aug 24 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- added RPM_OPT_FLAGS

* Sun Aug 15 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- modified the SPEC to compile on Solaris

* Sat Jul 31 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- modified postun script

* Thu Jul 22 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- updated to 1.21
- changed docs location

* Mon Jun 07 1999 Jean-Michel Dault <jmdault@netrevolution.com>
- put the doc in the html directory
- added post and postun scripts

* Tue May 11 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- Mandrake adaptations.

* Fri Apr 16 1999 Preston Brown <pbrown@redhat.com>
- bump ver. # so SWS mod_perl gets auto-upgraded

* Wed Apr 07 1999 Preston Brown <pbrown@redhat.com>
- bugfix 1.19 release from Doug

* Wed Mar 24 1999 Preston Brown <pbrown@redhat.com>
- experimental patch from Doug MacEachern <dougm@pobox.com> to fix segfault
- rebuilt against apache 1.3.6

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 3)

* Wed Feb 24 1999 Preston Brown <pbrown@redhat.com>
- Injected new description and group.

* Sun Feb 07 1999 Preston Brown <pbrown@redhat.com>
- upgraded to mod_perl 1.18.

* Mon Dec 21 1998 Preston Brown <pbrown@redhat.com>
- Upgraded to mod_perl 1.16.

* Thu Sep 03 1998 Preston Brown <pbrown@redhat.com>
- disabled stacked_handlers.  They still seem busted!
- minor updates so no conflicts with either apache / secureweb
- fixed bug building on multiple architectures

* Wed Sep 02 1998 Preston Brown <pbrown@redhat.com>
- Updates for apache 1.3.x, and mod_perl 1.15

* Fri Feb 27 1998 Cristian Gafton <gafton@redhat.com>
- added a patch to compile it as a shared object for the apache/ssl (and
  future revisions of apache)

